
#include <stdlib.h>
#include "curses.h"

struct kn {
	char *name;
	int code;
};

struct kn key_names[] = {
	{"key_a1", KEY_A1,},
	{"key_a3", KEY_A3,},
	{"key_b2", KEY_B2,},
	{"key_backspace", KEY_BACKSPACE,},
	{"key_beg", KEY_BEG,},
	{"key_btab", KEY_BTAB,},
	{"key_c1", KEY_C1,},
	{"key_c3", KEY_C3,},
	{"key_cancel", KEY_CANCEL,},
	{"key_catab", KEY_CATAB,},
	{"key_clear", KEY_CLEAR,},
	{"key_close", KEY_CLOSE,},
	{"key_command", KEY_COMMAND,},
	{"key_copy", KEY_COPY,},
	{"key_create", KEY_CREATE,},
	{"key_ctab", KEY_CTAB,},
	{"key_dc", KEY_DC,},
	{"key_dl", KEY_DL,},
	{"key_down", KEY_DOWN,},
	{"key_eic", KEY_EIC,},
	{"key_end", KEY_END,},
	{"key_enter", KEY_ENTER,},
	{"key_eol", KEY_EOL,},
	{"key_eos", KEY_EOS,},
	{"key_exit", KEY_EXIT,},
	{"key_f0", KEY_F(0),},
	{"key_f1", KEY_F(1),},
	{"key_f2", KEY_F(2),},
	{"key_f3", KEY_F(3),},
	{"key_f4", KEY_F(4),},
	{"key_f5", KEY_F(5),},
	{"key_f6", KEY_F(6),},
	{"key_f7", KEY_F(7),},
	{"key_f8", KEY_F(8),},
	{"key_f9", KEY_F(9),},
	{"key_f10", KEY_F(10),},
	{"key_f11", KEY_F(11),},
	{"key_f12", KEY_F(12),},
	{"key_f13", KEY_F(13),},
	{"key_f14", KEY_F(14),},
	{"key_f15", KEY_F(15),},
	{"key_f16", KEY_F(16),},
	{"key_f17", KEY_F(17),},
	{"key_f18", KEY_F(18),},
	{"key_f19", KEY_F(19),},
	{"key_f20", KEY_F(20),},
	{"key_f21", KEY_F(21),},
	{"key_f22", KEY_F(22),},
	{"key_f23", KEY_F(23),},
	{"key_f24", KEY_F(24),},
	{"key_f25", KEY_F(25),},
	{"key_f26", KEY_F(26),},
	{"key_f27", KEY_F(27),},
	{"key_f28", KEY_F(28),},
	{"key_f29", KEY_F(29),},
	{"key_f30", KEY_F(30),},
	{"key_f31", KEY_F(31),},
	{"key_f32", KEY_F(32),},
	{"key_f33", KEY_F(33),},
	{"key_f34", KEY_F(34),},
	{"key_f35", KEY_F(35),},
	{"key_f36", KEY_F(36),},
	{"key_f37", KEY_F(37),},
	{"key_f38", KEY_F(38),},
	{"key_f39", KEY_F(39),},
	{"key_f40", KEY_F(40),},
	{"key_f41", KEY_F(41),},
	{"key_f42", KEY_F(42),},
	{"key_f43", KEY_F(43),},
	{"key_f44", KEY_F(44),},
	{"key_f45", KEY_F(45),},
	{"key_f46", KEY_F(46),},
	{"key_f47", KEY_F(47),},
	{"key_f48", KEY_F(48),},
	{"key_f49", KEY_F(49),},
	{"key_f50", KEY_F(50),},
	{"key_f51", KEY_F(51),},
	{"key_f52", KEY_F(52),},
	{"key_f53", KEY_F(53),},
	{"key_f54", KEY_F(54),},
	{"key_f55", KEY_F(55),},
	{"key_f56", KEY_F(56),},
	{"key_f57", KEY_F(57),},
	{"key_f58", KEY_F(58),},
	{"key_f59", KEY_F(59),},
	{"key_f60", KEY_F(60),},
	{"key_f61", KEY_F(61),},
	{"key_f62", KEY_F(62),},
	{"key_f63", KEY_F(63),},
	{"key_find", KEY_FIND,},
	{"key_help", KEY_HELP,},
	{"key_home", KEY_HOME,},
	{"key_ic", KEY_IC,},
	{"key_il", KEY_IL,},
	{"key_left", KEY_LEFT,},
	{"key_ll", KEY_LL,},
	{"key_mark", KEY_MARK,},
	{"key_message", KEY_MESSAGE,},
	{"key_move", KEY_MOVE,},
	{"key_next", KEY_NEXT,},
	{"key_npage", KEY_NPAGE,},
	{"key_open", KEY_OPEN,},
	{"key_options", KEY_OPTIONS,},
	{"key_ppage", KEY_PPAGE,},
	{"key_previous", KEY_PREVIOUS,},
	{"key_print", KEY_PRINT,},
	{"key_redo", KEY_REDO,},
	{"key_reference", KEY_REFERENCE,},
	{"key_refresh", KEY_REFRESH,},
	{"key_replace", KEY_REPLACE,},
	{"key_restart", KEY_RESTART,},
	{"key_resume", KEY_RESUME,},
	{"key_right", KEY_RIGHT,},
	{"key_save", KEY_SAVE,},
	{"key_sbeg", KEY_SBEG,},
	{"key_scancel", KEY_SCANCEL,},
	{"key_scommand", KEY_SCOMMAND,},
	{"key_scopy", KEY_SCOPY,},
	{"key_screate", KEY_SCREATE,},
	{"key_sdc", KEY_SDC,},
	{"key_sdl", KEY_SDL,},
	{"key_select", KEY_SELECT,},
	{"key_send", KEY_SEND,},
	{"key_seol", KEY_SEOL,},
	{"key_sexit", KEY_SEXIT,},
	{"key_sf", KEY_SF,},
	{"key_sfind", KEY_SFIND,},
	{"key_shelp", KEY_SHELP,},
	{"key_shome", KEY_SHOME,},
	{"key_sic", KEY_SIC,},
	{"key_sleft", KEY_SLEFT,},
	{"key_smessage", KEY_SMESSAGE,},
	{"key_smove", KEY_SMOVE,},
	{"key_snext", KEY_SNEXT,},
	{"key_soptions", KEY_SOPTIONS,},
	{"key_sprevious", KEY_SPREVIOUS,},
	{"key_sprint", KEY_SPRINT,},
	{"key_sr", KEY_SR,},
	{"key_sredo", KEY_SREDO,},
	{"key_sreplace", KEY_SREPLACE,},
	{"key_sright", KEY_SRIGHT,},
	{"key_srsume", KEY_SRSUME,},
	{"key_ssave", KEY_SSAVE,},
	{"key_ssuspend", KEY_SSUSPEND,},
	{"key_stab", KEY_STAB,},
	{"key_sundo", KEY_SUNDO,},
	{"key_suspend", KEY_SUSPEND,},
	{"key_undo", KEY_UNDO,},
	{"key_up", KEY_UP,},
};

char *keyname(int c)
{
int i, size = sizeof(key_names)/sizeof(struct kn);

	for (i = 0; i < size; i++) {
		if (key_names[i].code == c) return key_names[i].name;
	}
	return NULL;
}

