/*
 * KON - Kanji ON Linux / FreeBSD Console -
 * Copyright (C) 1992, 1993 Takashi MANABE (manabe@tut.ac.jp)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY TAKASHI MANABE ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE TERRENCE R. LAMBERT BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 */

/* fnld.h -- font information */

#ifndef	FNLD_H
#define	FNLD_H

#include <interface.h>

struct fontRegs {
    u_int (*addr)(u_char ch1, u_char ch2);
    u_int size;
    char *registry, *bitmap;
    u_char high, width, sign0, sign1, stat;
};

struct langInfo {
    u_char
	sb,
	db,
	sc;
};

extern struct langInfo lInfo;

#define	FR_ATTACH	1
#define	FR_PROXY	2

extern struct fontRegs fSRegs[], fDRegs[];
extern struct fontRegs *sbFReg, *dbFReg;

/* bdf.c */
extern u_char	*FontLoad(u_char *fbuff, int fd, struct fontInfo *fi);

/* font.c */
extern u_char	*GetShmem(char type);
extern void	DownShmem(char type);

/* coding.c */
extern int	CodingByRegistry(char *reg);

/* load.c */
extern void	FontDetach(void);
extern void	FontAttach(void);

#endif
